/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.log.parser.api.model;

/**
 * A flow is a tree of flow steps.
 * <p>
 * The root is the flow step which has no parent and which has all the
 * others as descendants.
 * </p>
 *
 * @author Pierre-Yves Gibello - EBM WebSourcing
 */
public class Flow {

	String flowId;
	FlowStep root;


	/**
	 * Constructor.
	 * @param flowId the flow ID
	 * @param root the root flow step
	 */
	public Flow(String flowId, FlowStep root) {
		this.flowId = flowId;
		this.root = root;
	}

	/**
     * @return the root
     */
    public FlowStep getRoot() {
        return this.root;
    }

    /**
     * @param root the root to set
     */
    public void setRoot(FlowStep root) {
        this.root = root;
    }

    /**
     * @return the flowId
     */
    public String getFlowId() {
        return this.flowId;
    }

    /*
     * (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
		return this.root == null ? "null" : this.root.toString( new StringBuilder(), 0 );
	}
}
